Index: zfs-snapshot
===================================================================
--- zfs-snapshot	(revision 44)
+++ zfs-snapshot	(revision 45)
@@ -1,71 +1,15 @@
 #!/bin/bash
 # $Id$
 
-function check_env_volume {
-#*** CHECK DE L'ENVIRONNEMENT ***
-
-if [ ! -d "/mnt/snapshot" ]
-then
-   mkdir -p /mnt/snapshot
-   if [ $? -eq 1 ]
-   then
-      echo "/!\\ Probleme lors de la creation de /mnt/snapshot /!\\" 1>&2
-      exit 1
-   fi
-fi
-#*** FIN DU CHECK DE L'ENVIRONNEMENT ***
-}
-
-function check_env_filesystem {
-echo "**** $1"
-if [ "$#" -eq 0 ]
-then
-   echo "/!\\ Le fichier de configuration est manquant /!\\" 1>&2
-   exit 1
-fi 
-
-if [ ! -f $1 ]
-then
-   echo "/!\\ Le fichier de configuration n'existe pas /!\\" 1>&2
-   exit 1
-fi
-NAME_VOL=$(cat $1 |grep "name" |cut -d"=" -f2)
-TYPE_ZFS=$(cat $1 |grep "type" |cut -d"=" -f2)
-NB_SNAP=$(cat $1 |grep "nbsnapshots"|cut -d"=" -f2)
-if [ "$NAME_VOL" = "" ] || [ "$TYPE_ZFS" = "" ] || [ "$NB_SNAP" = "" ]
-then
-   echo "/!\\ Probleme le fichier de configuration est incoherent ou incomplet /!\\" 1>&2
-   exit 1
-fi
-
-
-}
-
 function create_snapshot_volume {
 #*** ETAPE DE CREATION DU SNAPSHOT ***#
 
 echo ""
-echo "*** Snapshot ZFS pour : $NAME_VOL"
-echo "*** Type de volume ZFS : $TYPE_ZFS"
+echo "*** Snapshot ZFS from : $NAME_VOL"
+echo "*** ZFS Type : $TYPE_ZFS"
 echo ""
 
-if [ "$TYPE_ZFS" = "volume" ]
-then
-   if [ ! -d /mnt/snapshot/$NAME_VOL ]
-   then
-      mkdir -p /mnt/snapshot/$NAME_VOL
-   fi
-   #mount -o ro /dev/zvol/$NAME_VOL /mnt/snapshot/$NAME_VOL
-   #if [ $? -eq 0 ]
-   #then
-   #   echo "*** Mount en lecture seule de $NAME_VOL [OK]"
-   #else
-   #   echo "/!\\ Probleme lors de la tentative de mount de $NAME_VOL sur /mnt/snapshot/$NAME_VOL /!\\" 1>&2
-   #   exit 1
-   #fi
-fi
-
-echo "*** Creation du snapshot pour $NAME_VOL"
+echo "*** Snapshot Creation from $NAME_VOL"
 ZDATE=$(date +%Y%m%d%H%M%S)
 /sbin/zfs snapshot $NAME_VOL@snapshot-$ZDATE
 echo ""
@@ -76,10 +20,10 @@
 #*** ETAPE DE CREATION DU SNAPSHOT ***#
 
 echo ""
-echo "*** Snapshot ZFS pour : $NAME_VOL"
-echo "*** Type de volume ZFS : $TYPE_ZFS"
+echo "*** Snapshot ZFS from : $NAME_VOL"
+echo "*** ZFS Type : $TYPE_ZFS"
 echo ""
-echo "*** Creation du snapshot pour $NAME_VOL"
+echo "*** Snapshot Creation from $NAME_VOL"
 ZDATE=$(date +%Y%m%d%H%M%S)
 /sbin/zfs snapshot $NAME_VOL@snapshot-$ZDATE
 echo ""
@@ -87,39 +31,6 @@
 }
 
 
-function check_after_snapshot_volume {
-#*** ETAPE DE VERIFICATION ***#
-echo "*** Umount du volume /mnt/snapshot/$NAME_VOL ..."
-umount /mnt/snapshot/$NAME_VOL
-if [ $? -eq 1 ]
-then
-   echo "/!\\ Probleme lors du demontage du volume $NAME_VOL /!\\" 1>&2
-fi
-
-mount -o ro /dev/zvol/$NAME_VOL@snapshot-$ZDATE /mnt/snapshot/$NAME_VOL
-if [ $? -eq 0 ]
-then
-   echo "*** Creation du snapshot et verification du montage du snapshot /dev/zvol/$NAME_VOL@snapshot-$ZDATE [OK]"
-   umount /mnt/snapshot/$NAME_VOL
-   if [ $? -eq 1 ]
-   then
-      echo "/!\\ Probleme lors du demontage du volume $NAME_VOL /!\\" 1>&2
-   fi
-
-else
-   echo "/!\\ Probleme avec lors de la creation ou du snapshot : commande de destruction de /dev/zvol/$NAME_VOL@snapshot-$ZDATE /!\\"
-   /sbin/zfs destroy $NAME_VOL@snapshot-$ZDATE
-   if [ $? -eq 0 ]
-   then
-      echo "*** Suppression du snapshot $NAME_VOL@snapshot-$ZDATE [OK]"
-   else
-      echo "/!\\ Suppression du snapshot $NAME_VOL@snapshot-$ZDATE [ERROR]. A TRAITER DANS LES PLUS BREFS DELAIS !!!" 1>&2
-   fi
-fi
-#*** FIN ETAPE DE VERIFICATION ***#
-}
-
-
 function del_old_snapshot {
 #*** ETAPE SUPPRESSION DES SNAPSHOTS OBSELETES ***#
 echo ""
@@ -150,13 +61,13 @@
 echo "**** $1"
 if [ "$#" -eq 0 ]
 then
-   echo "/!\\ Le fichier de configuration est manquant /!\\" 1>&2
+   echo "/!\\ File Configuration missing ... /!\\" 1>&2
    exit 1
 fi 
 
 if [ ! -f $1 ]
 then
-   echo "/!\\ Le fichier de configuration n'existe pas /!\\" 1>&2
+   echo "/!\\ File Configuration does not exist /!\\" 1>&2
    exit 1
 fi
 
@@ -165,15 +76,13 @@
 NB_SNAP=$(cat $1 |grep "nbsnapshots"|cut -d"=" -f2)
 if [ "$NAME_VOL" = "" ] || [ "$TYPE_ZFS" = "" ] || [ "$NB_SNAP" = "" ]
 then
-   echo "/!\\ Probleme le fichier de configuration est incoherent ou incomplet /!\\" 1>&2
+   echo "/!\\ Problem with the Configuration File : incoherence data or incomplete /!\\" 1>&2
    exit 1
 fi
 
 if [ "$TYPE_ZFS" == "volume" ]
 then
-   check_env_volume
    create_snapshot_volume
-   #check_after_snapshot_volume
    del_old_snapshot
 
 