Index: enable-replica
===================================================================
--- enable-replica	(revision 45)
+++ enable-replica	(revision 46)
@@ -44,17 +44,17 @@
 
 function interactive {
 zfs list
-echo "*** Choix du volume pour l'activation de la replication : ***" 
+echo "*** Select the ZFS volume/filesystem to replicate : ***" 
 
 while read inputline
 do
    volfs=$inputline
    if [ "$volfs" = "" ]
    then
-      echo "*** Choix du volume pour l'activation de la replication : ***" 
+      echo "*** Select the ZFS volume/filesystem to replicate : ***" 
    else
 
-      echo "*** Etes-vous sur du nom : $inputline ? (y/n) ***"
+      echo "*** Are you sur : $inputline ? (y/n) ***"
 
 
       while read inputConfirm
@@ -63,39 +63,39 @@
          then
             break
          fi
-         echo "*** Etes-vous sur du nom : $inputline ? (y/n) ***"
+         echo "*** Are you sur  : $inputline ? (y/n) ***"
       done
       if [ "$inputConfirm" = "y" ]
       then
          zfs list $volfs
          if [ $? -eq 0 ]
          then
-            echo "*** Le volume saisi $volfs existe ***"
+            echo "*** The ZFS volume/filesystem selected $volfs exists ***"
             break
          else
-            echo "*** Le volume saisi $volfs n'existe pas ***"    
-            echo "*** Choix du volume pour l'activation de la replication : ***"
+            echo "*** The ZFS volume/filesystem selected $volfs does not exist ***"    
+            echo "*** Select the ZFS volume/filesystem to replicate : ***"
          fi
       fi
       if [ "$inputConfirm" != "y" ]
       then
-         echo "*** Choix du volume pour l'activation de la replication : ***"
+         echo "*** Select the ZFS volume/filesystem to replicate : ***"
       fi
    fi
 done
 
-echo "*** Nom du replica (syntax pool_name/replica_name, exemple zpfront/monvolume) ***" 
-echo "*** /!\ Le programme ne verifiera pas la validite de votre saisie /!\***" 
+echo "*** Enter replica name (syntax pool_name/replica_name, example zpfront/monvolume) ***" 
+echo "*** /!\ This program does not check if the replica name is valid /!\***" 
 while read inputline
 do
    volfsdestination=$inputline
    if [ "$volfsdestination" = "" ]
    then
-      echo "*** Nom du replica (syntax pool_name/replica_name, exemple zpfront/monvolume) ***" 
-      echo "*** /!\ Le programme ne verifiera pas la validite de votre saisie /!\***" 
+      echo "*** Enter replica name (syntax pool_name/replica_name, example zpfront/monvolume) ***" 
+      echo "*** /!\ This program does not check if the replica name is valid /!\***" 
    else
 
-      echo "*** Etes-vous sur du nom du replica: $inputline ? (y/n) ***"
+      echo "*** Are you sur : $inputline ? (y/n) ***"
 
 
       while read inputConfirm
@@ -104,30 +104,30 @@
          then
             break
          fi
-         echo "*** Etes-vous sur du nom : $inputline ? (y/n) ***"
+         echo "*** Are you sur : $inputline ? (y/n) ***"
       done
       if [ "$inputConfirm" != "y" ]
       then
-         echo "*** Nom du replica (syntax pool_name/replica_name, exemple zpfront/monvolume) ***" 
-         echo "*** /!\ Le programme ne verifiera pas la validite de votre saisie /!\***" 
+         echo "*** Enter replica name (syntax pool_name/replica_name, example zpfront/monvolume) ***" 
+         echo "*** /!\ This program does not check if the replica name is valid /!\***" 
       else
         break
       fi
    fi
 done
 
-echo "*** La replica est-elle sur un serveur distant (y/n)?"
+echo "*** Replicate to a remote server (y/n)?"
 while read inputConfirm
 do
    if [ "$inputConfirm" = "y" ]||[ "$inputConfirm" = "n" ]
    then
       break
    fi
-   echo "*** Etes-vous sur du nom : $inputline ? (y/n) ***"
+   echo "*** Are you sur : $inputline ? (y/n) ***"
 done
 if [ "$inputConfirm" = "y" ]
 then
-   echo "*** Saisir le nom du server : "
+   echo "*** Enter server name : "
    while read inputserver
    do
       if [ "$inputserver" != "" ]
@@ -135,21 +135,21 @@
          server=$inputserver
          break
       fi
-      echo "*** Saisir le nom du server : "
+      echo "*** Enter server name : "
    done
 else
    server=""
 fi
    
-echo "*** Nombre de replica a garder : ***"
+echo "*** Enter the replica number to keep : ***"
 while read inputline
 do
    nbreplica=$inputline
    if [ "$nbreplica" = "" ]
    then
-     echo "*** Nombre de snapshot a garder : ***"
+     echo "*** Enter the replica number to keep : ***"
    else
-     echo "*** Creation du fichier de configuration ***"
+     echo "*** Creation of configuration file ***"
      FILE_NAME=$(echo "replica-"${volfs//\//-})
      >$DIR_CONF_REPLICA$FILE_NAME.conf
       echo "name=$volfs" >> $DIR_CONF_REPLICA$FILE_NAME.conf