Index: enable-snapshot
===================================================================
--- enable-snapshot	(revision 46)
+++ enable-snapshot	(revision 47)
@@ -39,17 +39,17 @@
 
 function interactive {
 /sbin/zfs list
-echo "*** Choix du volume pour l'activation des snapshot (merci de saisir le path complet du volume) : ***"
+echo "*** Select the ZFS volume/filesystem : ***"
 
 while read inputline
 do
    NAME_VOL=$inputline
    if [ "$NAME_VOL" = "" ]
    then
-      echo "*** Choix du volume pour l'activation des snapshot : ***" 
+      echo "*** Select the ZFS volume/filesystem : ***"
    else
 
-      echo "*** Etes-vous sur du nom : $inputline ? (y/n) ***"
+      echo "*** Are you sur : $inputline ? (y/n) ***"
    
 
       while read inputConfirm
@@ -58,7 +58,7 @@
          then
             break
          fi
-         echo "*** Etes-vous sur du nom : $inputline ? (y/n) ***"
+         echo "*** Are you sur : $inputline ? (y/n) ***"
       done
 
       if [ "$inputConfirm" = "y" ]
@@ -66,22 +66,22 @@
          /sbin/zfs list $NAME_VOL
          if [ $? -eq 0 ]
          then
-            echo "*** Le volume saisi $NAME_VOL existe ***"
+            echo "*** The ZFS volume/filesystem $NAME_VOL exists ***"
             break
          else
-            echo "*** Le volume saisi $NAME_VOL n'existe pas ***"    
-            echo "*** Choix du volume pour l'activation des snapshot : ***"
+            echo "*** The ZFS volume/filesystem $NAME_VOL does not exist ***"    
+            echo "*** Select the ZFS volume/filesystem : ***"
          fi
       fi
       if [ "$inputConfirm" != "y" ]
       then
-         echo "*** Choix du volume pour l'activation des snapshot : ***"
+         echo "*** Select the ZFS volume/filesystem : ***"
       fi
 
    fi
 done
 
-echo "*** Le volume est utilise en zfs natif ou en zvol (sous forme d'un device) : volume/filesystem ***"
+echo "*** ZFS Type : volume or filesystem ? ***"
 
 while read inputline
 do
@@ -90,14 +90,13 @@
      TYPE_ZFS=$inputline
      break
   else
-    echo "*** Le volume est utilise en zfs natif ou en zvol (sous forme d'un device) : volume/filesystem ***"
-     
+    echo "*** ZFS Type : volume or filesystem ? ***"
   fi
 
 done
 
 
-echo "*** Nombre de snapshot a garder : ***"
+echo "*** How many snapshot to keep ? ***"
 
 
 
@@ -107,11 +106,11 @@
    if [ "$NB_SNAP" = "" ]
    then
 
-       echo "*** Nombre de snapshot a garder : ***"
+       echo "*** How many snapshot to keep ? ***"
               
    else
        
-       echo "*** Creation du fichier de configuration ***"
+       echo "*** Creation of the configuration file ***"
        FILE_NAME=$(echo "snapshot-"${NAME_VOL//\//-}) 
        >$DIR_CONF_SNAPSHOT$FILE_NAME.conf
        echo "name=$NAME_VOL" > $DIR_CONF_SNAPSHOT$FILE_NAME.conf
@@ -121,99 +120,99 @@
    fi
 done
 
-echo "*** Frequence des snapshots ***"
-echo "1 - Tous les jours"
-echo "2 - Toutes les semaines"
-echo "3 - Tous les mois"
+echo "*** Snapshots Frequency ***"
+echo "1 - Every days"
+echo "2 - Every weeks"
+echo "3 - Every Months"
 echo "*******************************"
 while read inputline
 do 
    case $inputline in
    
     "1" )
-          echo "*** Saisir l'heure (HH:MM) "
+          echo "*** Enter the Time (HH:MM) "
           while read inputheure
           do
              if [[ "$inputheure" =~ [0-9][0-9]":"[0-9][0-9] ]]
              then
-                echo "Le choix de l'heure est : $inputheure"
+                echo "Snapshot will be taken at : $inputheure"
                 H_DEBUT=$(echo $inputheure |cut -d":" -f1)
                 M_DEBUT=$(echo $inputheure |cut -d":" -f2)
                 echo "$M_DEBUT $H_DEBUT * * * root $BIN_ZFS_SNAPSHOT $DIR_CONF_SNAPSHOT$FILE_NAME.conf" > $DIR_CRON$FILE_NAME
                 break;
              else
-                echo "*** Saisir l'heure (HH:MM) "
+                echo "*** Enter the Time (HH:MM) "
              fi
           done
 
           break ;;
     "2" ) 
-          echo "*** Saisir le jour de la semaine : 0-6 (0 est dimanche) "
+          echo "*** Select day of week : 0-6 (0 is sunday) "
           while read inputjour
           do
              if [[ "$inputjour" =~ [0-9] ]]
              then
                
-                 echo "*** Saisir l'heure (HH:MM) "
+                 echo "*** Enter the Time (HH:MM) "
                  while read inputheure
                  do
                     if [[ "$inputheure" =~ [0-9][0-9]":"[0-9][0-9] ]]
                     then
-                       echo "Le choix de l'heure est : $inputheure"
+                       echo "Snapshot will be taken at : $inputheure"
                        H_DEBUT=$(echo $inputheure |cut -d":" -f1)
                        M_DEBUT=$(echo $inputheure |cut -d":" -f2)
                        break;
                     else
-                       echo "*** Saisir l'heure (HH:MM) "
+                       echo "*** Enter the Time (HH:MM) "
                     fi
                   done
                 
                   echo "$M_DEBUT $H_DEBUT * * $inputjour root $BIN_ZFS_SNAPSHOT $DIR_CONF_SNAPSHOT$FILE_NAME.conf" > $DIR_CRON$FILE_NAME
-                  echo "*** Planification du snapshot [OK]"
+                  echo "*** Snapshot Configuration [OK]"
                   break;
              else
-                 echo "*** Saisir le jour de la semaine : 0-6 (0 est dimanche) "
+                 echo "*** Select day of week : 0-6 (0 is sunday) "
              fi
           done
 
           break ;;
 
      "3" )
-          echo "*** Saisir le jour du mois : 01-30"
+          echo "*** Selelct day of month : 01-30"
           while read inputjour
           do
              if [[ "$inputjour" =~ [0-9][0-9] ]]
              then
 
-                 echo "*** Saisir l'heure (HH:MM) "
+                 echo "*** Enter the Time (HH:MM) "
                  while read inputheure
                  do
                     if [[ "$inputheure" =~ [0-9][0-9]":"[0-9][0-9] ]]
                     then
-                       echo "Le choix de l'heure est : $inputheure"
+                       echo "Snapshot will be taken at : $inputheure"
                        H_DEBUT=$(echo $inputheure |cut -d":" -f1)
                        M_DEBUT=$(echo $inputheure |cut -d":" -f2)
                        break;
                     else
-                       echo "*** Saisir l'heure (HH:MM) "
+                       echo "*** Enter the Time (HH:MM) "
                     fi
                   done
 
                   echo "$M_DEBUT $H_DEBUT $inputjour * * root $BIN_ZFS_SNAPSHOT $DIR_CONF_SNAPSHOT$FILE_NAME.conf" > $DIR_CRON$FILE_NAME
-                  echo "*** Planification du snapshot [OK]"
+                  echo "*** Snapshot configuration [OK]"
                   break;
              else
-                 echo "*** Saisir le jour du mois : 01-30 "
+                 echo "*** Select the day of month : 01-30 "
              fi
           done
 
           break ;;
 
    esac
-   echo "*** Frequence des snapshots *** "
-   echo "1 - Tous les jours"
-   echo "2 - Toutes les semaines"
-   echo "3 - Tous les mois"
+   echo "*** Snapshots Frequency *** "
+   echo "1 - Every days"
+   echo "2 - Every weeks"
+   echo "3 - Every months"
    echo "*******************************"
    
 done